package com.logicbig.example;


import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestPart;
import javax.servlet.http.Part;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardCopyOption;

@Controller
@RequestMapping("/upload")
public class FileUploadController {
    public static final String TargetFolder = "d:/filesUploaded/";

    @GetMapping
    public String handleGetRequest() {
        return "file-upload";
    }

    @PostMapping
    public String handlePostRequest(@RequestPart("user-file") Part part,
                                    Model model) throws IOException {

        String name = extractFileName(part);
        InputStream inputStream = part.getInputStream();
        Files.copy(inputStream, Paths.get(TargetFolder + name), StandardCopyOption.REPLACE_EXISTING);
        model.addAttribute("msg", "File has been uploaded:  " + name);
        return "response";
    }

    private String extractFileName(Part part) {
        String disposition = part.getHeader("Content-Disposition");
        String fileName = disposition
                .replaceFirst("(?i)^.*filename=\"?([^\"]+)\"?.*$", "$1");
        return fileName;
    }
}